import { BehaviorSubject, throwError } from 'rxjs';
import { CommonModule } from '@angular/common';
import { HttpClientModule } from '@angular/common/http';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { ActivatedRoute, RouterModule } from '@angular/router';
import { Injectable, Component, Input, Output, EventEmitter, Pipe, defineInjectable, NgModule, inject } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AngularIEEEsbLibService {
    constructor() { }
}
AngularIEEEsbLibService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
AngularIEEEsbLibService.ctorParameters = () => [];
/** @nocollapse */ AngularIEEEsbLibService.ngInjectableDef = defineInjectable({ factory: function AngularIEEEsbLibService_Factory() { return new AngularIEEEsbLibService(); }, token: AngularIEEEsbLibService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AngularIEEEsbLibComponent {
    constructor() { }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
}
AngularIEEEsbLibComponent.decorators = [
    { type: Component, args: [{
                selector: 'ieee-AngularIEEEsbLib',
                template: `
    <p>
      angular-ieeesb-lib works!
    </p>
  `
            }] }
];
/** @nocollapse */
AngularIEEEsbLibComponent.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ButtonComponent {
    constructor() {
        this.label = [];
        this.disabled = false;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
}
ButtonComponent.decorators = [
    { type: Component, args: [{
                selector: 'ieeesb-button',
                template: "<a class=\"input-container w-100\" [class.disabled]=\"disabled\" [class.text-danger]=\"danger\" [routerLink]=\"\" *ngIf=\"!link\"><span class=\"text-center\">{{label}}</span></a>\n<a class=\"input-container w-100\" [class.disabled]=\"disabled\" [class.text-danger]=\"danger\" [routerLink]=\"[link]\" *ngIf=\"link\"><span class=\"text-center\">{{label}}</span></a>\n",
                styles: [".rounded{border-radius:.25rem!important}.shadow-center-2{box-shadow:0 3px 6px rgba(0,0,0,.16),0 3px 6px rgba(0,0,0,.23)}.shadow-center-3{box-shadow:0 6px 20px rgba(0,0,0,.19),0 6px 6px rgba(0,0,0,.23)}.input-container .input-button,.shadow-1{box-shadow:0 1px 3px rgba(0,0,0,.12),0 1px 2px rgba(0,0,0,.24)}.shadow-2{box-shadow:0 3px 6px rgba(0,0,0,.16),0 3px 6px rgba(0,0,0,.23)}.shadow-3{box-shadow:0 10px 20px rgba(0,0,0,.19),0 6px 6px rgba(0,0,0,.23)}.shadow-4{box-shadow:0 14px 28px rgba(0,0,0,.25),0 10px 10px rgba(0,0,0,.22)}.shadow-5{box-shadow:0 19px 38px rgba(0,0,0,.3),0 15px 12px rgba(0,0,0,.22)}.z-index-0{z-index:-10}.z-index-1{z-index:0}.z-index-2{z-index:10}.z-index-3{z-index:100}.z-index-4{z-index:1000}.rounded-top-0{border-top-left-radius:0!important;border-top-right-radius:0!important}.rounded-bottom-0{border-bottom-left-radius:0!important;border-bottom-right-radius:0!important}.center-childs{display:flex;align-items:center}.toggle{position:relative;display:block;width:40px;height:20px;cursor:pointer;-webkit-tap-highlight-color:transparent;-webkit-transform:translate3d(0,0,0);transform:translate3d(0,0,0)}.toggle:before{content:\"\";position:relative;top:3px;left:3px;width:34px;height:14px;display:block;background:#9a9999;border-radius:8px;transition:background .2s}.toggle span{position:absolute;top:0;left:0;width:20px;height:20px;display:block;background:#fff;border-radius:10px;box-shadow:0 3px 8px rgba(154,153,153,.5);transition:.2s}.toggle span:before{content:\"\";position:absolute;display:block;margin:-18px;width:56px;height:56px;background:rgba(79,46,220,.5);border-radius:50%;-webkit-transform:scale(0);transform:scale(0);opacity:1;pointer-events:none}.toggle.checked:before{background:#08c}.toggle.checked span{background:#069;-webkit-transform:translateX(20px);transform:translateX(20px);transition:.2s cubic-bezier(.8,.4,.3,1.25),background .15s;box-shadow:0 3px 8px rgba(0,102,153,.2)}.toggle.checked span:before{-webkit-transform:scale(1);transform:scale(1);opacity:0;transition:.4s}.input-container{padding:0!important;display:flex;align-items:center;cursor:pointer;text-decoration:none;user-drag:none;-webkit-user-drag:none}.input-container.disabled{pointer-events:none;opacity:.65}.input-container:hover{text-decoration:none!important}.input-container:focus{border-color:#ced4da!important;outline:0;box-shadow:none!important}.input-container .input-button{margin-left:auto;margin-right:auto;background-color:#069;text-align:center;color:#fff;font-size:20px;cursor:pointer;transition:.2s;padding-top:0;padding-bottom:0;border-radius:.25rem;width:100%}.input-container .input-button.danger{background-color:#dc3545}.input-container .input-button:hover{background-color:#046;transition:.2s}.input-container .input-button p{margin:0;padding:5px 0}"]
            }] }
];
/** @nocollapse */
ButtonComponent.ctorParameters = () => [];
ButtonComponent.propDecorators = {
    label: [{ type: Input }],
    link: [{ type: Input }],
    disabled: [{ type: Input }],
    danger: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class InputComponent {
    constructor() {
        this.label = '';
        this.editing = true;
        this.type = 'text';
        this.step = 1;
        this.min = 0;
        this.itemChange = new EventEmitter();
        this.enter = new EventEmitter();
    }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * @param {?} tag
     * @return {?}
     */
    addTag(tag) {
        if (!this.item) {
            this.item = [];
        }
        if (this.item.indexOf(tag) > -1)
            return;
        this.item.push(tag);
        this.itemChange.emit(this.item);
    }
    /**
     * @param {?} tag
     * @return {?}
     */
    removeTag(tag) {
        if (this.item.indexOf(tag) <= 0)
            return;
        this.item.splice(this.item.indexOf(tag), 1);
        this.itemChange.emit(this.item);
    }
}
InputComponent.decorators = [
    { type: Component, args: [{
                selector: 'ieeesb-input',
                template: "<div class=\"row mb-3 justify-content-center w-100\">\n\t<div class=\"col-4 label\">\n\t\t<span class=\"h6 text-center w-100 mb-0\">{{label}}:</span>\n\t</div>\n\n\t<div class=\"col-8 input-container\" *ngIf=\"editing && !tags\">\n\t\t<input type=\"text\" class=\"input-text\" [ngModel]=\"item\" (ngModelChange)=\"itemChange.emit($event)\" (keyup.enter)=\"enter.emit()\" [placeholder]=\"label\" *ngIf=\"type === 'text'\">\n\t\t<input type=\"number\" class=\"input-text\" [ngModel]=\"item\" [step]=\"step\" [min]=\"min\" [max]=\"max\" (ngModelChange)=\"itemChange.emit($event)\" (keyup.enter)=\"enter.emit()\" [placeholder]=\"label\" *ngIf=\"type === 'number'\">\n\t\t<span></span>\n\t</div>\n\n\t<div class=\"col-4 input-container\" *ngIf=\"!editing\">\n\t\t<span class=\"text-center\">{{item}}</span>\n\t</div>\n\n\t<div class=\"col-8 col-sm-4\" *ngIf=\"editing && tags\">\n\t\t<div class=\"row h-100 align-items-center\">\n\t\t\t<div class=\"col-6 pill-container\" *ngFor=\"let tag of item\">\n\t\t\t\t<a [routerLink]=\"\" (click)=\"removeTag(tag)\">\n\t\t\t\t\t<div class=\"pill link text-center\">\n\t\t\t\t\t\t{{tag}}\n\t\t\t\t\t</div>\n\t\t\t\t</a>\n\t\t\t</div>\n\t\t</div>\n\t</div>\n\t<div class=\"col-12 col-sm-4 mt-3 mt-sm-0\" *ngIf=\"editing && tags\">\n\t\t<ieeesb-search-dropdown [words]=\"tags\" (add)=\"addTag($event)\"></ieeesb-search-dropdown>\n\t</div>\n</div>\n",
                styles: [".pill-container .pill,.rounded{border-radius:.25rem!important}.shadow-center-2{box-shadow:0 3px 6px rgba(0,0,0,.16),0 3px 6px rgba(0,0,0,.23)}.shadow-center-3{box-shadow:0 6px 20px rgba(0,0,0,.19),0 6px 6px rgba(0,0,0,.23)}.pill-container .pill,.shadow-1{box-shadow:0 1px 3px rgba(0,0,0,.12),0 1px 2px rgba(0,0,0,.24)}.shadow-2{box-shadow:0 3px 6px rgba(0,0,0,.16),0 3px 6px rgba(0,0,0,.23)}.shadow-3{box-shadow:0 10px 20px rgba(0,0,0,.19),0 6px 6px rgba(0,0,0,.23)}.shadow-4{box-shadow:0 14px 28px rgba(0,0,0,.25),0 10px 10px rgba(0,0,0,.22)}.shadow-5{box-shadow:0 19px 38px rgba(0,0,0,.3),0 15px 12px rgba(0,0,0,.22)}.z-index-0{z-index:-10}.z-index-1{z-index:0}.z-index-2{z-index:10}.z-index-3{z-index:100}.z-index-4{z-index:1000}.rounded-top-0{border-top-left-radius:0!important;border-top-right-radius:0!important}.rounded-bottom-0{border-bottom-left-radius:0!important;border-bottom-right-radius:0!important}.center-childs{display:flex;align-items:center}.toggle{position:relative;display:block;width:40px;height:20px;cursor:pointer;-webkit-tap-highlight-color:transparent;-webkit-transform:translate3d(0,0,0);transform:translate3d(0,0,0)}.toggle:before{content:\"\";position:relative;top:3px;left:3px;width:34px;height:14px;display:block;background:#9a9999;border-radius:8px;transition:background .2s}.toggle span{position:absolute;top:0;left:0;width:20px;height:20px;display:block;background:#fff;border-radius:10px;box-shadow:0 3px 8px rgba(154,153,153,.5);transition:.2s}.toggle span:before{content:\"\";position:absolute;display:block;margin:-18px;width:56px;height:56px;background:rgba(79,46,220,.5);border-radius:50%;-webkit-transform:scale(0);transform:scale(0);opacity:1;pointer-events:none}.toggle.checked:before{background:#08c}.toggle.checked span{background:#069;-webkit-transform:translateX(20px);transform:translateX(20px);transition:.2s cubic-bezier(.8,.4,.3,1.25),background .15s;box-shadow:0 3px 8px rgba(0,102,153,.2)}.toggle.checked span:before{-webkit-transform:scale(1);transform:scale(1);opacity:0;transition:.4s}.input-container{padding:0!important;height:40px;display:flex;align-items:center}.input-container .input-text{padding:8px 5px;width:100%;border:none;background-color:#ffffff00}.input-container .input-text+span{position:absolute;background:#e88a0c;left:0;bottom:0;height:2px;width:100%}.input-container .input-text+span::after{content:\"\";background:#069;position:absolute;left:0;bottom:0;height:2px;width:0%;transition:.4s}.input-container .input-text:-webkit-autofill{-webkit-box-shadow:0 0 0 30px #fff inset}.input-container .input-text:focus{outline-color:transparent}.input-container .input-text:focus+span:after{content:\"\";background:#069;position:absolute;left:0;bottom:0;height:2px;width:100%;transition:.4s}.pill-container{padding:0 5px!important}.pill-container .pill{height:30px;margin:1px 0;background-color:#069;color:#fff}.pill-container .pill a{color:#dfdfdf!important}.pill-container .pill:hover a{color:#acacac!important}.label{display:flex;align-items:center}.label .text{padding:4px 0;margin:0;width:100%;text-align:center}"]
            }] }
];
/** @nocollapse */
InputComponent.ctorParameters = () => [];
InputComponent.propDecorators = {
    item: [{ type: Input }],
    label: [{ type: Input }],
    tags: [{ type: Input }],
    editing: [{ type: Input }],
    type: [{ type: Input }],
    step: [{ type: Input }],
    min: [{ type: Input }],
    max: [{ type: Input }],
    itemChange: [{ type: Output }],
    enter: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class SearchDropdownComponent {
    constructor() {
        this.search = '';
        this.focused = false;
        this.maxWords = 5;
        this.words = [];
        this._add = new EventEmitter();
    }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * @return {?}
     */
    add() {
        console.log('add: ', this.search);
        this._add.emit(this.search);
        this.search = '';
    }
    /**
     * @return {?}
     */
    get _words() {
        this.search = this.search.normalize('NFD').replace(/[\u0300-\u036f]/g, "").toLowerCase();
        /** @type {?} */
        let words = [];
        for (let word of this.words) {
            if (word.indexOf(this.search) > -1) {
                words.push(word);
            }
        }
        words = words.slice(0, this.maxWords);
        return words;
    }
    /**
     * @param {?} word
     * @return {?}
     */
    select(word) {
        console.log('word: ', word);
        this.search = word;
    }
}
SearchDropdownComponent.decorators = [
    { type: Component, args: [{
                selector: 'ieeesb-search-dropdown',
                template: "<div class=\"row\">\n\t<div class=\"col\">\n\t\t<div class=\"input-group\">\n\t\t\t<input type=\"text\" [(ngModel)]=\"search\" (focus)=\"focused = true\" (focusout)=\"focused = false\" class=\"form-control rounded-bottom-0\" [class.rounded-bottom-0]=\"_words.length > 0\">\n\t\t\t<div class=\"input-group-append\">\n\t\t\t\t<button type=\"button\" class=\"btn btn-primary\" (click)=\"add()\" [disabled]=\"search === ''\">A\u00F1adir</button>\n\t\t\t</div>\n\t\t</div>\n\t\t<div class=\"row w-100 position-absolute z-index-2 drop pb-4\" *ngIf=\"search.length > 0 || focused\">\n\t\t\t<div class=\"col bg-white shadow-2 rounded-bottom\" *ngIf=\"_words.length > 0\">\n\t\t\t\t<div class=\"\" *ngFor=\"let word of _words\">\n\t\t\t\t\t<a class=\"row justify-content-center py-2 border-bottom\" [routerLink]=\"\" (click)=\"select(word)\">\n\t\t\t\t\t\t<div class=\"col-auto\">\n\t\t\t\t\t\t\t{{word}}\n\t\t\t\t\t\t</div>\n\t\t\t\t\t</a>\n\t\t\t\t</div>\n\t\t\t</div>\n\t\t</div>\n\t</div>\n</div>\n",
                styles: [".drop{padding-left:15px;padding-right:15px}"]
            }] }
];
/** @nocollapse */
SearchDropdownComponent.ctorParameters = () => [];
SearchDropdownComponent.propDecorators = {
    words: [{ type: Input }],
    _add: [{ type: Output, args: ['add',] }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class SelectComponent {
    constructor() {
        this.item = {};
        this.label = '';
        this.options = [];
        this.optionsLabels = [];
        this.editing = true;
        this.itemChange = new EventEmitter();
    }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
}
SelectComponent.decorators = [
    { type: Component, args: [{
                selector: 'ieeesb-select',
                template: "<div class=\"row mb-3 justify-content-center\">\n\t<div class=\"col-4 label\">\n\t\t<p class=\"h6 text-center text\">{{label}}:</p>\n\t</div>\n\t<div class=\"col-8 input-container\" *ngIf=\"editing\">\n\t\t<select [ngModel]=\"item\" (ngModelChange)=\"itemChange.emit($event)\" class=\"input-select\" *ngIf=\"editing\">\n\t\t\t<option [ngValue]=\"option\" *ngFor=\"let option of options; let i = index;\">{{optionsLabels[i]}}</option>\n\t\t</select>\n\t</div>\n\t<div class=\"col-4 input-container\" *ngIf=\"!editing\">\n\t\t<span  class=\"text-center\">{{optionsLabels[options.indexOf(item)]}}</span>\n\t</div>\n</div>\n",
                styles: [".input-container{padding:0!important;min-height:40px;display:flex;align-items:center}.input-container .input-select{background-color:#4285f4;border:1px solid #e4e4e4;padding:0 9px;height:40px;color:#fff;outline:0;border-radius:.25rem!important}.input-container .input-select option{background-color:#4285f4}"]
            }] }
];
/** @nocollapse */
SelectComponent.ctorParameters = () => [];
SelectComponent.propDecorators = {
    item: [{ type: Input }],
    label: [{ type: Input }],
    options: [{ type: Input }],
    optionsLabels: [{ type: Input }],
    editing: [{ type: Input }],
    itemChange: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class LoadingService {
    constructor() {
        this.timeout = 250;
        this.loaders = 0;
        this.time = 0;
        this.loadingSubject = new BehaviorSubject(false);
    }
    /**
     * @return {?}
     */
    getLoading() {
        return this.loadingSubject.asObservable();
    }
    /**
     * @return {?}
     */
    setLoading() {
        this.loaders++;
        this.time = Date.now();
        this.loadingSubject.next(true);
    }
    /**
     * @return {?}
     */
    unsetLoading() {
        this.loaders--;
        if (this.loaders == 0) {
            setTimeout((/**
             * @return {?}
             */
            () => {
                this.loadingSubject.next(false);
            }), this.timeout - (Date.now() - this.time));
        }
    }
}
LoadingService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
LoadingService.ctorParameters = () => [];
/** @nocollapse */ LoadingService.ngInjectableDef = defineInjectable({ factory: function LoadingService_Factory() { return new LoadingService(); }, token: LoadingService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class UtilsService {
    /**
     * @param {?} route
     * @param {?} loadingService
     */
    constructor(route, loadingService) {
        this.route = route;
        this.loadingService = loadingService;
        this.paramsSubject = new BehaviorSubject(null);
        route.queryParams.subscribe((/**
         * @param {?} params
         * @return {?}
         */
        params => {
            if (Object.keys(params).length > 0)
                this.setParams(params);
        }));
    }
    /**
     * @param {?} params
     * @return {?}
     */
    objectToQuerystring(params) {
        return '?' + Object.keys(params).map((/**
         * @param {?} key
         * @return {?}
         */
        key => key + '=' + params[key])).join('&');
    }
    /**
     * @param {?} on
     * @param {?} callback
     * @return {?}
     */
    setRedirect(on, callback) {
        if (this.redirectParams)
            return;
        this.redirectParams = { on, callback };
    }
    /**
     * @return {?}
     */
    getRedirect() {
        return this.redirectParams;
    }
    /**
     * @param {?} on
     * @param {?} params
     * @param {?=} navigate
     * @return {?}
     */
    redirect(on, params, navigate) {
        if (this.redirectParams) {
            if (this.redirectParams && this.redirectParams.on === on) {
                window.location.replace(`${this.redirectParams.callback}${this.objectToQuerystring(params)}`);
                return false;
            }
            return [`/${this.redirectParams.on}`];
        }
        if (navigate) {
            return navigate;
        }
    }
    /**
     * @param {?} params
     * @return {?}
     */
    setParams(params) {
        this.paramsSubject.next(params);
    }
    /**
     * @return {?}
     */
    getParams() {
        return this.paramsSubject.asObservable();
    }
    /**
     * @param {?} options
     * @return {?}
     */
    filter(options) {
        /** @type {?} */
        const search = options.search.normalize('NFD').replace(/[\u0300-\u036f]/g, "").toLowerCase();
        /** @type {?} */
        let items = [];
        for (let item of options.items) {
            for (let key of options.keys) {
                if (Array.isArray(item[key])) {
                    /** @type {?} */
                    let result = false;
                    for (let word of item[key]) {
                        if (word.normalize('NFD').replace(/[\u0300-\u036f]/g, "").toLowerCase().indexOf(search) > -1) {
                            items.push(item);
                            result = true;
                            break;
                        }
                    }
                    if (result)
                        break;
                    continue;
                }
                if (item[key].normalize('NFD').replace(/[\u0300-\u036f]/g, "").toLowerCase().indexOf(search) > -1) {
                    items.push(item);
                    break;
                }
            }
        }
        return items;
    }
    /**
     * @param {?} error
     * @return {?}
     */
    handleError(error) {
        this.loadingService.unsetLoading();
        /** @type {?} */
        let errorText;
        if (error.error instanceof ProgressEvent) {
            // A client-side or network error occurred. Handle it accordingly.
            console.error('An error occurred:', error.message);
            errorText = 'Error en la red';
        }
        else {
            console.error(`Backend returned code ${error.status}, body was: `, error.error);
            switch (error.error.code) {
                case 'duplicate_key':
                    errorText = `Parámetro ${error.error.key} duplicado`;
                    break;
                case 'invalid_parameters':
                    errorText = `Parámetro ${error.error.violations[0].context.label} inválido`;
                    break;
                default:
                    errorText = error.error.message;
                    break;
            }
        }
        // return an observable with a user-facing error message
        return throwError(errorText);
    }
}
UtilsService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
UtilsService.ctorParameters = () => [
    { type: ActivatedRoute },
    { type: LoadingService }
];
/** @nocollapse */ UtilsService.ngInjectableDef = defineInjectable({ factory: function UtilsService_Factory() { return new UtilsService(inject(ActivatedRoute), inject(LoadingService)); }, token: UtilsService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class PaginationComponent {
    constructor() {
        this.pageSize = 10;
        this.maxPages = 3;
        this.itemsChange = new EventEmitter();
        this.page = 1;
    }
    /**
     * @return {?}
     */
    get pages() {
        return Math.ceil(this.items.length / this.pageSize);
    }
    /**
     * @return {?}
     */
    get numbers() {
        /** @type {?} */
        let first = Math.round(this.page - this.maxPages / 2);
        first = first < 1 ? 1 : first;
        /** @type {?} */
        let last = first + this.maxPages - 1;
        last = last > this.pages ? this.pages : last;
        /** @type {?} */
        let ans = [];
        for (let i = first; i <= last; i++) {
            ans.push(i);
        }
        return ans;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        if (this.page > this.pages) {
            this.page = this.pages;
        }
        if (this.page < 1) {
            this.page = 1;
        }
        this.updateItems();
    }
    /**
     * @return {?}
     */
    updateItems() {
        this.itemsChange.emit(this.items.slice((this.page - 1) * this.pageSize, this.page * this.pageSize));
    }
    /**
     * @param {?} page
     * @return {?}
     */
    goPage(page) {
        this.page = page;
        this.updateItems();
    }
    /**
     * @return {?}
     */
    nextPage() {
        this.page++;
        this.updateItems();
    }
    /**
     * @return {?}
     */
    prevPage() {
        this.page--;
        this.updateItems();
    }
}
PaginationComponent.decorators = [
    { type: Component, args: [{
                selector: 'ieeesb-pagination',
                template: "<nav aria-label=\"Page navigation example\" *ngIf=\"items.length > 0\">\n\t<ul class=\"pagination\">\n\t\t<li class=\"page-item\">\n\t\t\t<a class=\"page-link\" [routerLink]=\"\" (click)=\"prevPage()\" [class.disabled]=\"page <= 1\">\n\t\t\t\t<span>Anterior</span>\n\t\t\t</a>\n\t\t</li>\n\t\t<li class=\"page-item\" *ngIf=\"numbers[0] !== 1\"><a class=\"page-link\" [routerLink]=\"\" (click)=\"goPage(1)\">{{1}}</a></li>\n\t\t<li class=\"page-item\" *ngFor=\"let i of numbers\" [class.active]=\"i === page\"><a class=\"page-link\" [routerLink]=\"\" (click)=\"goPage(i)\">{{i}}</a></li>\n\t\t<li class=\"page-item\" *ngIf=\"numbers[numbers.length - 1] !== pages\"><a class=\"page-link\" [routerLink]=\"\" (click)=\"goPage(pages)\">{{pages}}</a></li>\n\t\t<li class=\"page-item\">\n\t\t\t<a class=\"page-link\" [routerLink]=\"\" (click)=\"nextPage()\" [class.disabled]=\"page >= pages\">\n\t\t\t\t<span>Siguiente</span>\n\t\t\t</a>\n\t\t</li>\n\t</ul>\n</nav>\n",
                styles: [""]
            }] }
];
/** @nocollapse */
PaginationComponent.ctorParameters = () => [];
PaginationComponent.propDecorators = {
    items: [{ type: Input }],
    pageSize: [{ type: Input }],
    maxPages: [{ type: Input }],
    itemsChange: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class SearchComponent {
    /**
     * @param {?} utilsService
     */
    constructor(utilsService) {
        this.utilsService = utilsService;
        this.items = [];
        this.keys = [];
        this.itemsChange = new EventEmitter();
        this.search = '';
    }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        this.filter();
    }
    /**
     * @return {?}
     */
    filter() {
        this.itemsChange.emit(this.utilsService.filter({
            search: this.search,
            keys: this.keys,
            items: this.items,
        }));
    }
}
SearchComponent.decorators = [
    { type: Component, args: [{
                selector: 'ieeesb-search',
                template: "<div class=\"input-group\">\n\t<input type=\"text\" [(ngModel)]=\"search\" (ngModelChange)=\"filter()\" class=\"form-control\" placeholder=\"Buscar o comprar...\" autofocus>\n\t<span class=\"input-group-append\">\n\t\t<button class=\"btn btn-secondary\" type=\"button\"><span class=\"fas fa-search\"></span>&#0;</button>\n\t</span>\n</div>\n",
                styles: [""]
            }] }
];
/** @nocollapse */
SearchComponent.ctorParameters = () => [
    { type: UtilsService }
];
SearchComponent.propDecorators = {
    items: [{ type: Input }],
    keys: [{ type: Input }],
    itemsChange: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ListComponent {
    constructor() {
        this.rawItems = [];
        this.labels = [];
        this.keys = [];
        this.dateFormat = 'dd/MM/yyyy';
        this.linkKey = '';
        this.linkLabel = '';
        this.disabled = '';
        this.items = [];
        this._callback = new EventEmitter();
    }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * @param {?} item
     * @return {?}
     */
    callback(item) {
        console.log(item);
        this._callback.emit(this.linkKey.split('.').reduce((/**
         * @param {?} prev
         * @param {?} curr
         * @return {?}
         */
        (prev, curr) => prev && prev[curr]), item));
    }
}
ListComponent.decorators = [
    { type: Component, args: [{
                selector: 'ieeesb-list',
                template: "<div class=\"main\">\n\t<table class=\"table\">\n\t\t<thead>\n\t\t\t<tr>\n\t\t\t\t<th scope=\"col\" *ngFor=\"let label of labels\"><span>{{label}}</span></th>\n\t\t\t\t<th></th>\n\t\t\t</tr>\n\t\t</thead>\n\t\t<tbody>\n\t\t\t<tr class=\"\" *ngFor=\"let item of items\">\n\t\t\t\t<ng-container *ngFor=\"let key of keys; let i = index\">\n\t\t\t\t\t<th scope=\"row\" *ngIf=\"i === 0\">\n\t\t\t\t\t\t<ng-container *ngIf=\"link\">\n\t\t\t\t\t\t\t<a class=\"\" [routerLink]=\"[link + (item | property:linkKey)]\">\n\t\t\t\t\t\t\t\t<span *ngIf=\"key.toLowerCase().includes('date')\">{{item | property:key | date:dateFormat}}</span>\n\t\t\t\t\t\t\t\t<span *ngIf=\"!key.toLowerCase().includes('date')\">{{item | property:key}}</span>\n\t\t\t\t\t\t\t</a>\n\t\t\t\t\t\t</ng-container>\n\t\t\t\t\t\t<ng-container *ngIf=\"!link\">\n\t\t\t\t\t\t\t<span *ngIf=\"key.toLowerCase().includes('date')\">{{item | property:key | date:dateFormat}}</span>\n\t\t\t\t\t\t\t<span *ngIf=\"!key.toLowerCase().includes('date')\">{{item | property:key}}</span>\n\t\t\t\t\t\t</ng-container>\n\t\t\t\t\t</th>\n\t\t\t\t\t<td *ngIf=\"i !== 0\">\n\t\t\t\t\t\t<span *ngIf=\"key.toLowerCase().includes('date')\">{{item | property:key | date:dateFormat}}</span>\n\t\t\t\t\t\t<span *ngIf=\"!key.toLowerCase().includes('date')\">{{item | property:key}}</span>\n\t\t\t\t\t</td>\n\t\t\t\t</ng-container>\n\n\t\t\t\t<td>\n\t\t\t\t\t<ieeesb-button [label]=\"linkLabel\" [link]=\"link + (item | property:linkKey)\" (click)=\"callback($event)\" *ngIf=\"link\" [disabled]=\"item | property:disabled\"></ieeesb-button>\n\t\t\t\t\t<ieeesb-button [label]=\"linkLabel\" (click)=\"callback($event)\" *ngIf=\"!link\" [disabled]=\"item | property:disabled\"></ieeesb-button>\n\t\t\t\t</td>\n\t\t\t</tr>\n\t\t</tbody>\n\t</table>\n\t<div class=\"row justify-content-center mt-3 mx-0\">\n\t\t<div class=\"col-auto\">\n\t\t\t<ieeesb-pagination [items]=\"rawItems\" (itemsChange)=\"items=$event\" pageSize=\"10\"></ieeesb-pagination>\n\t\t</div>\n\t</div>\n\t<div *ngIf=\"!items || items.length <= 0\">\n\t\tNo hay resultados...\n\t</div>\n</div>\n",
                styles: [".main{overflow-x:auto}td,th{border-top:0!important;border-bottom:0!important;text-align:center!important}span{white-space:nowrap;width:100%}"]
            }] }
];
/** @nocollapse */
ListComponent.ctorParameters = () => [];
ListComponent.propDecorators = {
    rawItems: [{ type: Input, args: ['items',] }],
    labels: [{ type: Input }],
    keys: [{ type: Input }],
    dateFormat: [{ type: Input }],
    link: [{ type: Input }],
    linkKey: [{ type: Input }],
    linkLabel: [{ type: Input }],
    disabled: [{ type: Input }],
    _callback: [{ type: Output, args: ['callback',] }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class PropertyPipe {
    /**
     * @param {?} value
     * @param {?=} args
     * @return {?}
     */
    transform(value, args) {
        /** @type {?} */
        const properties = Array.isArray(args) ? args : args.split('.');
        return properties.reduce((/**
         * @param {?} prev
         * @param {?} curr
         * @return {?}
         */
        (prev, curr) => prev && prev[curr]), value);
    }
}
PropertyPipe.decorators = [
    { type: Pipe, args: [{
                name: 'property'
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class MenuComponent {
    constructor() {
        this.navbarOpen = false;
    }
    /**
     * @return {?}
     */
    ngOnInit() { }
    /**
     * @return {?}
     */
    toggleNavbar() {
        console.log('toogle');
        this.navbarOpen = !this.navbarOpen;
    }
    /**
     * @param {?} roles
     * @return {?}
     */
    userHasRoles(roles) {
        if (!this.user)
            return false;
        return roles.reduce((/**
         * @param {?} l
         * @param {?} a
         * @return {?}
         */
        (l, a) => this.user.roles.indexOf(a) >= 0 && l), true);
    }
}
MenuComponent.decorators = [
    { type: Component, args: [{
                selector: 'ieeesb-menu',
                template: "<nav class=\"navbar navbar-expand-lg navbar-light\" [ngClass]=\"{ 'fixed-left': align === 'left', 'fixed-right': align === 'right' }\">\n\t<a class=\"navbar-brand\" href=\"#\">\n\t\t<img alt=\"Logo IEEEsb\" src=\"assets/logo_entero.svg\">\n\t</a>\n\t<button class=\"navbar-toggler mr-2\" type=\"button\" (click)=\"toggleNavbar()\">\n\t\t<span class=\"navbar-toggler-icon\"></span>\n\t</button>\n\t<div class=\"collapse navbar-collapse\" [ngClass]=\"{ 'show': navbarOpen }\">\n\t\t<ul class=\"navbar-nav mr-auto\">\n\t\t\t<div *ngFor=\"let item of items.left\">\n\t\t\t\t<div *ngIf=\"(!item.roles && !user) || (item.roles && userHasRoles(item.roles))\">\n\t\t\t\t\t<li *ngIf=\"item.type === 'router'\" class=\"nav-item\" [ngClass]=\"{ 'active': activeLink.startsWith(item.link) }\">\n\t\t\t\t\t\t<a class=\"nav-link\" [routerLink]=\"item.link\"><span>{{item.text}}</span></a>\n\t\t\t\t\t</li>\n\t\t\t\t\t<li *ngIf=\"item.type === 'link'\" class=\"nav-item\">\n\t\t\t\t\t\t<a class=\"nav-link\" [href]=\"item.link\"><span>{{item.text}}</span></a>\n\t\t\t\t\t</li>\n\t\t\t\t\t<li *ngIf=\"item.type === 'callback'\" class=\"nav-item\">\n\t\t\t\t\t\t<a class=\"nav-link\" href=\"javascript:;\" (click)=\"item.callback()\"><span>{{item.text}}</span></a>\n\t\t\t\t\t</li>\n\t\t\t\t\t<li *ngIf=\"item.type === 'text'\" class=\"nav-item text\">\n\t\t\t\t\t\t<a class=\"nav-link\"><span>{{item.text}}</span></a>\n\t\t\t\t\t</li>\n\t\t\t\t</div>\n\t\t\t</div>\n\t\t</ul>\n\t\t<ul class=\"navbar-nav ml-auto\">\n\t\t\t<div *ngFor=\"let item of items.right\">\n\t\t\t\t<div *ngIf=\"(!item.roles && !user) || (item.roles && userHasRoles(item.roles))\">\n\t\t\t\t\t<li *ngIf=\"item.type === 'router'\" class=\"nav-item\" [ngClass]=\"{ 'active': activeLink.startsWith(item.link) }\">\n\t\t\t\t\t\t<a class=\"nav-link\" [routerLink]=\"item.link\"><span>{{item.text}}</span></a>\n\t\t\t\t\t</li>\n\t\t\t\t\t<li *ngIf=\"item.type === 'link'\" class=\"nav-item\">\n\t\t\t\t\t\t<a class=\"nav-link\" [href]=\"item.link\"><span>{{item.text}}</span></a>\n\t\t\t\t\t</li>\n\t\t\t\t\t<li *ngIf=\"item.type === 'callback'\" class=\"nav-item\">\n\t\t\t\t\t\t<a class=\"nav-link\" href=\"javascript:;\" (click)=\"item.callback()\"><span>{{item.text}}</span></a>\n\t\t\t\t\t</li>\n\t\t\t\t\t<li *ngIf=\"item.type === 'text'\" class=\"nav-item text\">\n\t\t\t\t\t\t<a class=\"nav-link\"><span>{{item.text}}</span></a>\n\t\t\t\t\t</li>\n\t\t\t\t</div>\n\t\t\t</div>\n\t\t</ul>\n\t</div>\n</nav>\n",
                styles: [".navbar{color:#fff;padding:0;background-color:#4285f4;box-shadow:0 -3px 20px 0 #000}.navbar .navbar-brand{color:#fff;padding:0 15px;display:flex;align-items:center;margin:0;z-index:10;background-color:#fff!important}.navbar:not(.fixed-left):not(.fixed-right) .navbar-brand{height:50px}.navbar:not(.fixed-left):not(.fixed-right) img{height:40px}.navbar .navbar-collapse{border-top:1px solid #0000007d}.navbar .nav-item{height:50px}.navbar .nav-item.active,.navbar .nav-item:hover:not(.text){background-color:#519ffc!important}.navbar .nav-item a{display:flex;align-items:center;height:100%;padding:0 15px;color:#fff}@media (min-width:992px){.navbar .navbar-brand{box-shadow:3px 0 20px -10px #000}.navbar .navbar-collapse{border-top:none}.navbar.fixed-left{right:auto;float:left}.navbar.fixed-right{left:auto;float:right}.navbar.fixed-left,.navbar.fixed-right{height:100%;flex-flow:column nowrap;align-items:flex-start;bottom:0}.navbar.fixed-left .navbar-brand,.navbar.fixed-right .navbar-brand{padding-top:10px;padding-bottom:10px;box-shadow:0 3px 20px -10px #000}.navbar.fixed-left .navbar-brand img,.navbar.fixed-right .navbar-brand img{height:auto!important;width:160px!important}}@media (max-width:991px){.navbar.fixed-left .navbar-brand,.navbar.fixed-right .navbar-brand{height:50px;padding-top:10px;padding-bottom:10px}.navbar.fixed-left .navbar-brand img,.navbar.fixed-right .navbar-brand img{height:50px;width:auto}}.navbar.fixed-left .navbar-collapse,.navbar.fixed-right .navbar-collapse{flex-grow:0;flex-direction:column;width:100%}.navbar.fixed-left .navbar-collapse .navbar-nav,.navbar.fixed-right .navbar-collapse .navbar-nav{flex-direction:column;width:100%}.navbar.fixed-left .navbar-collapse .navbar-nav .nav-item,.navbar.fixed-right .navbar-collapse .navbar-nav .nav-item{width:100%}.navbar.fixed-left .navbar-collapse .navbar-nav .nav-item span,.navbar.fixed-right .navbar-collapse .navbar-nav .nav-item span{text-align:center;width:100%}.navbar.fixed-left .navbar-collapse .navbar-nav .nav-item .dropdown-toggle:after,.navbar.fixed-right .navbar-collapse .navbar-nav .nav-item .dropdown-toggle:after{border-top:2px solid transparent;border-left:2px solid;border-bottom:2px solid transparent;border-right:none;vertical-align:baseline}.navbar.fixed-left .navbar-collapse .navbar-nav .nav-item .dropdown-menu,.navbar.fixed-right .navbar-collapse .navbar-nav .nav-item .dropdown-menu{left:100%;top:0}"]
            }] }
];
/** @nocollapse */
MenuComponent.ctorParameters = () => [];
MenuComponent.propDecorators = {
    items: [{ type: Input }],
    align: [{ type: Input }],
    user: [{ type: Input }],
    activeLink: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class SectionComponent {
    constructor() { }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
}
SectionComponent.decorators = [
    { type: Component, args: [{
                selector: 'ieeesb-section',
                template: "<div class=\"row justify-content-center mt-2\">\n\t<div class=\"col-8\">\n\t\t<hr>\n\t</div>\n</div>\n<div class=\"row justify-content-center pt-4 pb-2 mb-3 mx-0\">\n\t<div class=\"col px-0\">\n\t\t<ng-content></ng-content>\n\t</div>\n</div>\n",
                styles: ["hr{border-top:1px solid #006df0;margin-top:0;margin-bottom:0}"]
            }] }
];
/** @nocollapse */
SectionComponent.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AngularIEEEsbLibModule {
    /**
     * @return {?}
     */
    static forRoot() {
        return {
            ngModule: AngularIEEEsbLibModule,
            providers: [UtilsService, LoadingService,]
        };
    }
}
AngularIEEEsbLibModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    AngularIEEEsbLibComponent,
                    InputComponent,
                    SelectComponent,
                    SearchDropdownComponent,
                    ButtonComponent,
                    PaginationComponent,
                    SearchComponent,
                    ListComponent,
                    PropertyPipe,
                    MenuComponent,
                    SectionComponent,
                ],
                imports: [
                    FormsModule,
                    ReactiveFormsModule,
                    CommonModule,
                    RouterModule,
                    HttpClientModule,
                ],
                providers: [
                    UtilsService,
                    LoadingService,
                ],
                exports: [
                    InputComponent,
                    SelectComponent,
                    SearchDropdownComponent,
                    ButtonComponent,
                    PaginationComponent,
                    SearchComponent,
                    ListComponent,
                    MenuComponent,
                    SectionComponent,
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { AngularIEEEsbLibService, AngularIEEEsbLibComponent, ButtonComponent, InputComponent, SearchDropdownComponent, SelectComponent, UtilsService, LoadingService, AngularIEEEsbLibModule, ListComponent as ɵc, MenuComponent as ɵe, PaginationComponent as ɵa, PropertyPipe as ɵd, SearchComponent as ɵb, SectionComponent as ɵf };

//# sourceMappingURL=angular-ieeesb-lib.js.map